const C3 = self.C3;

const BEHAVIOR_INFO = {
    id: "skymen_tiled_sprite",
    Acts: {
      "SetImageOffsetX": {
            "forward": (inst) => inst._SetImageOffsetX,
            
            "autoScriptInterface": true,
            },
"SetImageOffsetY": {
            "forward": (inst) => inst._SetImageOffsetY,
            
            "autoScriptInterface": true,
            },
"SetImageScaleX": {
            "forward": (inst) => inst._SetImageScaleX,
            
            "autoScriptInterface": true,
            },
"SetImageScaleY": {
            "forward": (inst) => inst._SetImageScaleY,
            
            "autoScriptInterface": true,
            },
"SetImageAngle": {
            "forward": (inst) => inst._SetImageAngle,
            
            "autoScriptInterface": true,
            },
"SetTileRandomizationEnabled": {
            "forward": (inst) => inst._SetTileRandomizationEnabled,
            
            "autoScriptInterface": true,
            },
"SetTileXRandom": {
            "forward": (inst) => inst._SetTileXRandom,
            
            "autoScriptInterface": true,
            },
"SetTileYRandom": {
            "forward": (inst) => inst._SetTileYRandom,
            
            "autoScriptInterface": true,
            },
"SetTileAngleRandom": {
            "forward": (inst) => inst._SetTileAngleRandom,
            
            "autoScriptInterface": true,
            },
"SetTileBlendMarginX": {
            "forward": (inst) => inst._SetTileBlendMarginX,
            
            "autoScriptInterface": true,
            },
"SetTileBlendMarginY": {
            "forward": (inst) => inst._SetTileBlendMarginY,
            
            "autoScriptInterface": true,
            },
"LoadURL": {
            "forward": (inst) => inst.LoadURL,
            
            "autoScriptInterface": false,
            }
    },
    Cnds: {
      "IsTileRandomizationEnabled": {
            "forward": (inst) => inst._IsTileRandomizationEnabled,
            
            "autoScriptInterface": true,
          }
    },
    Exps: {
      "ImageOffsetX": {
            "forward": (inst) => inst._GetImageOffsetX,
            
            "autoScriptInterface": true,
          },
"ImageOffsetY": {
            "forward": (inst) => inst._GetImageOffsetY,
            
            "autoScriptInterface": true,
          },
"ImageScaleX": {
            "forward": (inst) => inst._GetImageScaleX,
            
            "autoScriptInterface": true,
          },
"ImageScaleY": {
            "forward": (inst) => inst._GetImageScaleY,
            
            "autoScriptInterface": true,
          },
"ImageAngle": {
            "forward": (inst) => inst._GetImageAngle,
            
            "autoScriptInterface": true,
          },
"IsTileRandomizationEnabled": {
            
            "handler": function () {
        return this._enableTileRandomization?1:0;
      },
            "autoScriptInterface": false,
          },
"TileXRandom": {
            "forward": (inst) => inst._GetTileXRandom,
            
            "autoScriptInterface": true,
          },
"TileYRandom": {
            "forward": (inst) => inst._GetTileYRandom,
            
            "autoScriptInterface": true,
          },
"TileAngleRandom": {
            "forward": (inst) => inst._GetTileAngleRandom,
            
            "autoScriptInterface": true,
          },
"TileBlendMarginX": {
            "forward": (inst) => inst._GetTileBlendMarginX,
            
            "autoScriptInterface": true,
          },
"TileBlendMarginY": {
            "forward": (inst) => inst._GetTileBlendMarginY,
            
            "autoScriptInterface": true,
          }
    },
  };

const camelCasedMap = new Map();

function camelCasify(str) {
  // If the string is already camelCased, return it
  if (camelCasedMap.has(str)) {
    return camelCasedMap.get(str);
  }
  // Replace any non-valid JavaScript identifier characters with spaces
  let cleanedStr = str.replace(/[^a-zA-Z0-9$_]/g, " ");

  // Split the string on spaces
  let words = cleanedStr.split(" ").filter(Boolean);

  // Capitalize the first letter of each word except for the first one
  for (let i = 1; i < words.length; i++) {
    words[i] = words[i].charAt(0).toUpperCase() + words[i].substring(1);
  }

  // Join the words back together
  let result = words.join("");

  // If the first character is a number, prepend an underscore
  if (!isNaN(parseInt(result.charAt(0)))) {
    result = "_" + result;
  }

  camelCasedMap.set(str, result);

  return result;
}

C3.Behaviors[BEHAVIOR_INFO.id] = class extends C3.SDKBehaviorBase {
  constructor(opts) {
    super(opts);
  }

  Release() {
    super.Release();
  }
};
const B_C = C3.Behaviors[BEHAVIOR_INFO.id];
B_C.Type = class extends C3.SDKBehaviorTypeBase {
  constructor(objectClass) {
    super(objectClass);
  }

  Release() {
    super.Release();
  }

  OnCreate() {}
};

//====== SCRIPT INTERFACE ======
const map = new WeakMap();

function getScriptInterface(parentClass, map) {
  return class extends parentClass {
    constructor() {
      super();
      map.set(this, parentClass._GetInitInst().GetSdkInstance());
      this.LOAD_RESIZE_MODE = {
        RESIZE: 0,
        NO_RESIZE: 1,
      };
      this.LOAD_CROSS_ORIGIN = {
        ANONYMOUS: 0,
        NONE: 1,
      };
    }

    IsTileRandomizationEnabled() {
      return map.get(this)._enableTileRandomization;
    }
    LoadURL(url, resizeMode, crossOrigin) {
      map.get(this).LoadURL(url, resizeMode, crossOrigin);
    }
  };
}


const scriptInterface = getScriptInterface(self.IBehaviorInstance, map);

// extend script interface with plugin actions
Object.keys(BEHAVIOR_INFO.Acts).forEach((key) => {
  const ace = BEHAVIOR_INFO.Acts[key];
  if (!ace.autoScriptInterface) return;
  if (ace.isAsync) {
    scriptInterface.prototype[camelCasify(key)] = async function (...args) {
      const sdkInst = map.get(this);
      await B_C.Acts[camelCasify(key)].call(sdkInst, ...args);
    };
  } else {
    scriptInterface.prototype[camelCasify(key)] = function (...args) {
      const sdkInst = map.get(this);
      B_C.Acts[camelCasify(key)].call(sdkInst, ...args);
    };
  }
});

const addonTriggers = [];

// extend script interface with plugin conditions
Object.keys(BEHAVIOR_INFO.Cnds).forEach((key) => {
  const ace = BEHAVIOR_INFO.Cnds[key];
  if (!ace.autoScriptInterface || ace.isStatic || ace.isLooping) return;
  if (ace.isTrigger) {
    scriptInterface.prototype[camelCasify(key)] = function (callback, ...args) {
      const callbackWrapper = () => {
        const sdkInst = map.get(this);
        if (B_C.Cnds[camelCasify(key)].call(sdkInst, ...args)) {
          callback();
        }
      };
      this.addEventListener(key, callbackWrapper, false);
      return () => this.removeEventListener(key, callbackWrapper, false);
    };
  } else {
    scriptInterface.prototype[camelCasify(key)] = function (...args) {
      const sdkInst = map.get(this);
      return B_C.Cnds[camelCasify(key)].call(sdkInst, ...args);
    };
  }
});

// extend script interface with plugin expressions
Object.keys(BEHAVIOR_INFO.Exps).forEach((key) => {
  const ace = BEHAVIOR_INFO.Exps[key];
  if (!ace.autoScriptInterface) return;
  scriptInterface.prototype[camelCasify(key)] = function (...args) {
    const sdkInst = map.get(this);
    return B_C.Exps[camelCasify(key)].call(sdkInst, ...args);
  };
});
//====== SCRIPT INTERFACE ======

//============ ACES ============
B_C.Acts = {};
B_C.Cnds = {};
B_C.Exps = {};
Object.keys(BEHAVIOR_INFO.Acts).forEach((key) => {
  const ace = BEHAVIOR_INFO.Acts[key];
  B_C.Acts[camelCasify(key)] = function (...args) {
    if (ace.forward) ace.forward(this).call(this, ...args);
    else if (ace.handler) ace.handler.call(this, ...args);
  };
});
Object.keys(BEHAVIOR_INFO.Cnds).forEach((key) => {
  const ace = BEHAVIOR_INFO.Cnds[key];
  B_C.Cnds[camelCasify(key)] = function (...args) {
    if (ace.forward) return ace.forward(this).call(this, ...args);
    if (ace.handler) return ace.handler.call(this, ...args);
  };
  if (ace.isTrigger && ace.autoScriptInterface) {
    addonTriggers.push({
      method: B_C.Cnds[camelCasify(key)],
      id: key,
    });
  }
});
Object.keys(BEHAVIOR_INFO.Exps).forEach((key) => {
  const ace = BEHAVIOR_INFO.Exps[key];
  B_C.Exps[camelCasify(key)] = function (...args) {
    if (ace.forward) return ace.forward(this).call(this, ...args);
    if (ace.handler) return ace.handler.call(this, ...args);
  };
});
//============ ACES ============

function getInstanceJs(parentClass, scriptInterface, addonTriggers, C3) {
  const tempRect = C3.New(C3.Rect);
  const tempQuad = C3.New(C3.Quad);
  const rcTex = C3.New(C3.Rect);
  const qTex = C3.New(C3.Quad);
  function WrapModeToStr(wrapMode) {
    switch (wrapMode) {
      case 0:
        return "clamp-to-edge";
      case 1:
        return "repeat";
      case 2:
        return "mirror-repeat";
    }
    return "repeat";
  }

  return class extends parentClass {
    constructor(inst, properties) {
      super(inst);
      this._wrapHorizontal = 0;
      this._wrapVertical = 0;
      this._imageOffsetX = 0;
      this._imageOffsetY = 0;
      this._imageScaleX = 1;
      this._imageScaleY = 1;
      this._imageAngle = 0;
      this._enableTileRandomization = false;
      this._tileXRandom = 0;
      this._tileYRandom = 0;
      this._tileAngleRandom = 0;
      this._tileBlendMarginX = 0;
      this._tileBlendMarginY = 0;

      this.isCreatingTextures = false;
      this._forceAssetLoading = false;

      if (
        !C3.Plugins.Sprite ||
        !(this._inst.GetPlugin() instanceof C3.Plugins.Sprite)
      ) {
        throw new Error("This behavior needs to be used on a Sprite plugin");
      }

      this._inst._objectType._skymen_textureData =
        this._inst._objectType._skymen_textureData || new WeakMap();

      this._inst.Draw = (renderer) => {
        this.Draw(renderer);
      };

      if (properties) {
        this._wrapHorizontal = WrapModeToStr(properties[0]);
        this._wrapVertical = WrapModeToStr(properties[1]);
        this._imageOffsetX = properties[2];
        this._imageOffsetY = properties[3];
        this._imageScaleX = properties[4];
        this._imageScaleY = properties[5];
        this._imageAngle = C3.toRadians(properties[6]);
        this._enableTileRandomization = !!properties[7];
        this._tileXRandom = properties[8];
        this._tileYRandom = properties[9];
        this._tileAngleRandom = properties[10];
        this._tileBlendMarginX = properties[11];
        this._tileBlendMarginY = properties[12];
        this._forceAssetLoading = properties[13] === 1;
      }
    }

    Release() {
      super.Release();
    }

    SetTilingShaderProgram(renderer) {
      if (this._enableTileRandomization) {
        const imageInfo = this._inst._sdkInst.GetCurrentImageInfo();
        renderer.SetTileRandomizationMode();
        renderer.SetTileRandomizationInfo(
          imageInfo.GetWidth() * this._imageScaleX,
          imageInfo.GetHeight() * this._imageScaleY,
          this._tileXRandom,
          this._tileYRandom,
          this._tileAngleRandom,
          this._tileBlendMarginX,
          this._tileBlendMarginY
        );
      } else renderer.SetTextureFillMode();
    }

    async LoadURL(url, resize, crossOrigin) {
      const curAnimFrame = this._inst._sdkInst._currentAnimationFrame;
      const curImageInfo = curAnimFrame.GetImageInfo();
      const wi = this._inst._sdkInst.GetWorldInfo();
      const runtime = this._inst._sdkInst._runtime;
      const sdkType = this._inst._sdkInst._sdkType;
      if (curImageInfo.GetURL() === url) {
        if (resize === 0) {
          wi.SetSize(curImageInfo.GetWidth(), curImageInfo.GetHeight());
          wi.SetBboxChanged();
        }
        this._inst._sdkInst.Trigger(C3.Plugins.Sprite.Cnds.OnURLLoaded);
        return;
      }
      const imageInfo = C3.New(C3.ImageInfo);
      try {
        await imageInfo.LoadDynamicAsset(runtime, url);
        if (!imageInfo.IsLoaded()) throw new Error("image failed to load");
        if (this._inst._sdkInst.WasReleased()) {
          imageInfo.Release();
          return;
        }
        await imageInfo.LoadStaticTexture(runtime.GetRenderer(), {
          sampling: runtime.GetSampling(),
          wrapX: this._wrapHorizontal,
          wrapY: this._wrapVertical,
        });
      } catch (err) {
        console.error("Load image from URL failed: ", err);
        if (!this._inst._sdkInst.WasReleased())
          this._inst._sdkInst.Trigger(C3.Plugins.Sprite.Cnds.OnURLFailed);
        return;
      }
      if (this._inst._sdkInst.WasReleased()) {
        imageInfo.Release();
        return;
      }
      curImageInfo.ReplaceWith(imageInfo);
      sdkType._UpdateAllCurrentTexture();
      sdkType
        .GetObjectClass()
        .Dispatcher()
        .dispatchEvent(new C3.Event("animationframeimagechange"));
      runtime.UpdateRender();
      if (resize === 0) {
        wi.SetSize(curImageInfo.GetWidth(), curImageInfo.GetHeight());
        wi.SetBboxChanged();
      }
      await this._inst._sdkInst.TriggerAsync(
        C3.Plugins.Sprite.Cnds.OnURLLoaded
      );
    }

    async LoadTexture(renderer, imageInfo, opts) {
      let canvas = await imageInfo.ExtractImageToCanvas();
      let newTexture = await renderer.CreateStaticTextureAsync(canvas, opts);
      this._inst._objectType._skymen_textureData.set(imageInfo, newTexture);
      this._runtime.UpdateRender();
    }

    async CreateAllTextures(renderer) {
      this._inst._objectType._skymen_isCreatingTextures = true;
      const opts = {
        sampling: this._runtime.GetSampling(),
        wrapX: this._wrapHorizontal,
        wrapY: this._wrapVertical,
      };
      for (const a of this._inst._objectType._animations) {
        for (const f of a._frames) {
          let imageInfo = f.GetImageInfo();
          this._inst._objectType._skymen_textureData.set(imageInfo, null);
          let promise = this.LoadTexture(renderer, imageInfo, opts);
          if (!this._forceAssetLoading) {
            await promise;
          }
        }
      }
    }

    Draw(renderer) {
      const imageInfo = this._inst._sdkInst.GetCurrentImageInfo();
      const texture = this._inst._sdkInst._currentTexture;
      if (texture === null) return;
      const myRealTexture =
        this._inst._objectType._skymen_textureData.get(imageInfo);
      if (!this._inst._objectType._skymen_isCreatingTextures) {
        this.CreateAllTextures(renderer);
        return;
      }
      if (myRealTexture === null) return;
      this.SetTilingShaderProgram(renderer);
      renderer.SetTexture(myRealTexture);
      const imageWidth = imageInfo.GetWidth();
      const imageHeight = imageInfo.GetHeight();
      const imageOffsetX = this._imageOffsetX / imageWidth;
      const imageOffsetY = this._imageOffsetY / imageHeight;
      const wi = this._inst.GetWorldInfo();
      rcTex.set(
        0,
        0,
        wi.GetWidth() / (imageWidth * this._imageScaleX),
        wi.GetHeight() / (imageHeight * this._imageScaleY)
      );
      rcTex.offset(-imageOffsetX, -imageOffsetY);
      if (wi.HasMesh()) this._DrawMesh(wi, renderer);
      else this._DrawStandard(wi, renderer);
    }
    _DrawStandard(wi, renderer) {
      let quad = wi.GetBoundingQuad();
      if (this._runtime.IsPixelRoundingEnabled())
        quad = wi.PixelRoundQuad(quad);
      if (this._imageAngle === 0) renderer.Quad3(quad, rcTex);
      else {
        qTex.setFromRotatedRect(rcTex, -this._imageAngle);
        renderer.Quad4(quad, qTex);
      }
    }
    _DrawMesh(wi, renderer) {
      const transformedMesh = wi.GetTransformedMesh();
      if (wi.IsMeshChanged()) {
        wi.CalculateBbox(tempRect, tempQuad, false);
        let quad = tempQuad;
        if (this._runtime.IsPixelRoundingEnabled())
          quad = wi.PixelRoundQuad(quad);
        let texCoords = rcTex;
        if (this._imageAngle !== 0) {
          qTex.setFromRotatedRect(rcTex, -this._imageAngle);
          texCoords = qTex;
        }
        transformedMesh.CalculateTransformedMesh(
          wi.GetSourceMesh(),
          quad,
          texCoords
        );
        wi.SetMeshChanged(false);
      }
      transformedMesh.Draw(renderer);
    }
    IsOriginalSizeKnown() {
      return true;
    }
    _SetMeshChanged() {
      this._inst.GetWorldInfo().SetMeshChanged(true);
    }
    _SetImageOffsetX(x) {
      if (this._imageOffsetX === x) return;
      this._imageOffsetX = x;
      this._runtime.UpdateRender();
      this._SetMeshChanged();
    }
    _GetImageOffsetX() {
      return this._imageOffsetX;
    }
    _SetImageOffsetY(y) {
      if (this._imageOffsetY === y) return;
      this._imageOffsetY = y;
      this._runtime.UpdateRender();
      this._SetMeshChanged();
    }
    _GetImageOffsetY() {
      return this._imageOffsetY;
    }
    _SetImageScaleX(x) {
      if (this._imageScaleX === x) return;
      this._imageScaleX = x;
      this._runtime.UpdateRender();
      this._SetMeshChanged();
    }
    _GetImageScaleX() {
      return this._imageScaleX;
    }
    _SetImageScaleY(y) {
      if (this._imageScaleY === y) return;
      this._imageScaleY = y;
      this._runtime.UpdateRender();
      this._SetMeshChanged();
    }
    _GetImageScaleY() {
      return this._imageScaleY;
    }
    _SetImageAngle(a) {
      a = C3.toRadians(a);
      if (this._imageAngle === a) return;
      this._imageAngle = a;
      this._runtime.UpdateRender();
      this._SetMeshChanged();
    }
    _GetImageAngle() {
      return C3.toDegrees(this._imageAngle);
    }
    _SetTileRandomizationEnabled(e) {
      e = !!e;
      if (this._enableTileRandomization === e) return;
      this._enableTileRandomization = e;
      this._runtime.UpdateRender();
    }
    _IsTileRandomizationEnabled() {
      return this._enableTileRandomization;
    }
    _SetTileXRandom(x) {
      if (this._tileXRandom === x) return;
      this._tileXRandom = x;
      if (this._IsTileRandomizationEnabled()) this._runtime.UpdateRender();
    }
    _GetTileXRandom() {
      return this._tileXRandom;
    }
    _SetTileYRandom(y) {
      if (this._tileYRandom === y) return;
      this._tileYRandom = y;
      if (this._IsTileRandomizationEnabled()) this._runtime.UpdateRender();
    }
    _GetTileYRandom() {
      return this._tileYRandom;
    }
    _SetTileAngleRandom(a) {
      if (this._tileAngleRandom === a) return;
      this._tileAngleRandom = a;
      if (this._IsTileRandomizationEnabled()) this._runtime.UpdateRender();
    }
    _GetTileAngleRandom() {
      return this._tileAngleRandom;
    }
    _SetTileBlendMarginX(x) {
      if (this._tileBlendMarginX === x) return;
      this._tileBlendMarginX = x;
      if (this._IsTileRandomizationEnabled()) this._runtime.UpdateRender();
    }
    _GetTileBlendMarginX() {
      return this._tileBlendMarginX;
    }
    _SetTileBlendMarginY(y) {
      if (this._tileBlendMarginY === y) return;
      this._tileBlendMarginY = y;
      if (this._IsTileRandomizationEnabled()) this._runtime.UpdateRender();
    }
    _GetTileBlendMarginY() {
      return this._tileBlendMarginY;
    }
    GetDebuggerProperties() {
      return [
        {
          title: "Tiling Sprite Properties",
          properties: [
            {
              name: "Image Offset X",
              value: this._GetImageOffsetX(),
              onedit: (v) => this._SetImageOffsetX(v),
            },
            {
              name: "Image Offset Y",
              value: this._GetImageOffsetY(),
              onedit: (v) => this._SetImageOffsetY(v),
            },
            {
              name: "Image Scale X",
              value: this._GetImageScaleX() * 100,
              onedit: (v) => this._SetImageScaleX(v / 100),
            },
            {
              name: "Image Scale Y",
              value: this._GetImageScaleY() * 100,
              onedit: (v) => this._SetImageScaleY(v / 100),
            },
            {
              name: "Image Angle",
              value: this._GetImageAngle(),
              onedit: (v) => this._SetImageAngle(v),
            },
          ],
        },
        {
          title: "Tiling Sprite Randomization Properties",
          properties: [
            {
              name: "Enable Tile Randomization",
              value: this._IsTileRandomizationEnabled(),
              onedit: (v) => this._SetTileRandomizationEnabled(v),
            },
            {
              name: "X Random",
              value: this._GetTileXRandom() * 100,
              onedit: (v) => this._SetTileXRandom(v / 100),
            },
            {
              name: "Y Random",
              value: this._GetTileYRandom() * 100,
              onedit: (v) => this._SetTileYRandom(v / 100),
            },
            {
              name: "Angle Random",
              value: this._GetTileAngleRandom() * 100,
              onedit: (v) => this._SetTileAngleRandom(v / 100),
            },
            {
              name: "Blend Margin X",
              value: this._GetTileBlendMarginX() * 100,
              onedit: (v) => this._SetTileBlendMarginX(v / 100),
            },
            {
              name: "Blend Margin Y",
              value: this._GetTileBlendMarginY() * 100,
              onedit: (v) => this._SetTileBlendMarginY(v / 100),
            },
          ],
        },
      ];
    }

    SaveToJson() {
      return {
        wrapHorizontal: this._wrapHorizontal,
        wrapVertical: this._wrapVertical,
        imageOffsetX: this._imageOffsetX,
        imageOffsetY: this._imageOffsetY,
        imageScaleX: this._imageScaleX,
        imageScaleY: this._imageScaleY,
        imageAngle: this._imageAngle,
        enableTileRandomization: this._enableTileRandomization,
        tileXRandom: this._tileXRandom,
        tileYRandom: this._tileYRandom,
        tileAngleRandom: this._tileAngleRandom,
        tileBlendMarginX: this._tileBlendMarginX,
        tileBlendMarginY: this._tileBlendMarginY,
        isCreatingTextures: this.isCreatingTextures,
      };
    }

    LoadFromJson(o) {
      this._wrapHorizontal = o.wrapHorizontal;
      this._wrapVertical = o.wrapVertical;
      this._imageOffsetX = o.imageOffsetX;
      this._imageOffsetY = o.imageOffsetY;
      this._imageScaleX = o.imageScaleX;
      this._imageScaleY = o.imageScaleY;
      this._imageAngle = o.imageAngle;
      this._enableTileRandomization = o.enableTileRandomization;
      this._tileXRandom = o.tileXRandom;
      this._tileYRandom = o.tileYRandom;
      this._tileAngleRandom = o.tileAngleRandom;
      this._tileBlendMarginX = o.tileBlendMarginX;
      this._tileBlendMarginY = o.tileBlendMarginY;
      this.isCreatingTextures = o.isCreatingTextures;
    }

    Trigger(method) {
      super.Trigger(method);
      const addonTrigger = addonTriggers.find((x) => x.method === method);
      if (addonTrigger) {
        this.GetScriptInterface().dispatchEvent(new C3.Event(addonTrigger.id));
      }
    }

    GetScriptInterfaceClass() {
      return scriptInterface;
    }
  };
}


B_C.Instance = getInstanceJs(
  C3.SDKBehaviorInstanceBase,
  scriptInterface,
  addonTriggers,
  C3
);
